import org.json.*;

String api  = "http://api.flickr.com/services/rest/?method=flickr.photos.search";
String apiKey = "f2bf6e099d13319aa0a9363272de8e68";
String tag = "lunareclipse";
int numOfResults = 250; //Unlike standard photo queries, geo (or bounding box) queries will only return 250 results per page 

PFont font1 = createFont("Helvetica", 8);
PImage backgroundMap;

float[] lat = new float [numOfResults];
float[] lon = new float [numOfResults];
int[][] dateTaken = new int [numOfResults][6];
int[] tempMonth = new int [numOfResults];
String[] whichMonth = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
String[] dateTag = new String [numOfResults];
int[] splResults = new int[12];

Map map = new HashMap();

float mapGeoLeft   = -200.00;          
float mapGeoRight  =  195.00;          
float mapGeoTop    =   105.00;       
float mapGeoBottom =  -105.00;     
                         
float mapScreenWidth, mapScreenHeight;  

void setup(){
  size(1000,700);
  colorMode(HSB, 100);
  //background(0, 0, 100);
  smooth();
  stroke(0,0,100);
  backgroundMap   = loadImage("worldMap.jpg");
  mapScreenWidth  = width;
  mapScreenHeight = 600;
  
  //Flickr lat and lon
  String requestLatLon = api + "&tags=" + tag + "&has_geo=1&per_page=" + numOfResults + "&min_taken_date=2008-01-01&max_taken_date=2008-12-31&format=json&nojsoncallback=1&extras=geo&api_key=" + apiKey;
  String resultLatLon = join( loadStrings( requestLatLon ), "");
  try {
    JSONObject flickrDataLatLon = new JSONObject(join(loadStrings(requestLatLon), ""));
    JSONObject flickrDataPhotosLatLon = new JSONObject(flickrDataLatLon.getString("photos") )  ;
    JSONArray resultsLatLon = flickrDataPhotosLatLon.getJSONArray("photo"); 
   
    int numberOfElements = resultsLatLon.length();
    
    for (int j = 0; j < numberOfElements; j++) {
      JSONObject entryLatLon = resultsLatLon.getJSONObject(j);
      String tempLat = entryLatLon.getString("latitude");
      String tempLon = entryLatLon.getString("longitude");
      lat[j] = Float.parseFloat(tempLat);
      lon[j] = Float.parseFloat(tempLon);   
    }
  }
  catch (JSONException e) {
    println ("There was an error parsing the JSONObject.");
  }
  
  //Flickr dateTaken
  String requestDate = api + "&tags=" + tag + "&has_geo=1&per_page=" + numOfResults + "&min_taken_date=2008-01-01&max_taken_date=2008-12-31&format=json&nojsoncallback=1&extras=date_taken&api_key=" + apiKey;
  String resultDate = join( loadStrings( requestDate ), "");
  try {
    JSONObject flickrDataDate = new JSONObject(join(loadStrings(requestDate), ""));
    JSONObject flickrDataPhotosDate = new JSONObject(flickrDataDate.getString("photos") )  ;
    JSONArray resultsDate = flickrDataPhotosDate.getJSONArray("photo"); 
   
    int numberOfElements = resultsDate.length();
    
    for (int j = 0; j < numberOfElements; j++) {
      JSONObject entryDate = resultsDate.getJSONObject(j);
      dateTag[j] = entryDate.getString("datetaken");
      String tempDate[] = splitTokens(entryDate.getString("datetaken"), "- :");
      
      for (int i = 0; i < 6; i++){
      dateTaken[j][i] = Integer.parseInt(tempDate[i]);         
      }
    }
  }
  catch (JSONException e) {
    println ("There was an error parsing the JSONObject.");
  }
  
  for (int i = 0; i < dateTaken.length; i++){
    int key = dateTaken[i][1];
    NameAndNumber nan = (NameAndNumber) map.get(key);
      if (nan == null){
      // New entry
      map.put(key, new NameAndNumber(key, 1));
      } else {
      map.put(key, new NameAndNumber(key, nan.m_number + 1));
      }
  }
  
  // Sort the collection
  ArrayList keys = new ArrayList(map.keySet());
  Collections.sort(keys, new NameAndNumberComparator(map));

  // List occurrences
  int MAX = dateTaken.length; int count = 0;
  Iterator it = keys.iterator();
  while (it.hasNext() && count < MAX){
    int key = (Integer) it.next();
    NameAndNumber nan = (NameAndNumber) map.get(key);
    tempMonth[key] = nan.m_number;
    //println(key + " : " + nan.m_number);
    count++;
  }
  
  String splData[] = loadStrings("splData.txt");
  for (int i = 0; i < splData.length; i++) {
    String temp[] = split(splData[i], ",");
    splResults[i] = Integer.parseInt(temp[1]);
  }
}

void draw()
{ 
  image(backgroundMap,0,0,mapScreenWidth,700);
  
  textSize(15);
  textAlign(LEFT);
  fill((214.0/360.0) * 100.0, 55, 35, 100);
  text("Flickr", 50, 50);
  fill((20.0/360.0) * 100.0, 95, 94, 100);
  text("Seattle Public Library", 100, 50);    
  fill(0, 0, 0, 100);
  text("/", 90, 50);
  text(": Lunar Eclipse (2008)", 250, 50);
  
  //PVector m = pixelToGeo(new PVector(mouseX,mouseY));
  //println("x: " + m.x);
  //println("y: " + m.y);  
   
  for (int i = 0; i < numOfResults; i++){
    //Draw geo location
    PVector pixel = geoToPixel(new PVector(lon[i],lat[i]));  
    stroke(0, 0, 100);
    strokeWeight(1);
    fill((214.0/360.0) * 100.0, 55, 35, 50);
    ellipse(pixel.x, pixel.y, 10, 10);
    //Rollover    
    float mouseXpos = pixel.x;
    float mouseYpos = pixel.y;
    if(abs(mouseX - mouseXpos) < (5.0) && abs(mouseY - mouseYpos) < (5.0)){
      textAlign(LEFT);
      textSize(12);
      fill((214.0/360.0) * 100.0, 55, 35, 100);
      text(dateTag[i], mouseX, mouseY - 5.0);
    }
  }
  for (int i = 1; i < 13; i++){
    //Draw month
    fill(0, 0, 0, 100);
    textAlign(CENTER);
    textSize(12);
    text(whichMonth[i-1], (width / 12) + (i * 65) - 5, 500);
    
    //Draw Flickr chart
    fill((214.0/360.0) * 100.0, 55, 35, 50);
    ellipse((width / 12) + (i * 65) - 5, 550, ((tempMonth[i]/250.0) * 100.0) + 5.0, ((tempMonth[i]/250.0) * 100.0) + 5.0);
    
    //Flickr chart rollover
    float mouseXpos2 = (width / 12) + (i * 65) - 5;
    float mouseYpos2 = 550;
    if(abs(mouseX - mouseXpos2) < ((((tempMonth[i]/250.0) * 100.0) + 5.0) / 2) && abs(mouseY - mouseYpos2) < ((((tempMonth[i]/250.0) * 100.0) + 5.0) / 2)){
      textAlign(LEFT);
      textSize(12);
      fill((214.0/360.0) * 100.0, 55, 35, 100);
      text(tempMonth[i], mouseX, mouseY - 5.0);     
    }
    
    //Draw SPL chart
    fill((20.0/360.0) * 100.0, 95, 94, 50);
    ellipse((width / 12) + (i * 65) - 5, 600, (splResults[i-1] * 6.0) + 5.0, (splResults[i-1] * 6.0) + 5.0);   
    
    //Flickr chart rollover
    float mouseYpos3 = 600;
    if(abs(mouseX - mouseXpos2) < (((splResults[i-1] * 10.0) + 5.0) / 2) && abs(mouseY - mouseYpos3) < (((splResults[i-1] * 10.0) + 5.0) / 2)){
      textAlign(LEFT);
      textSize(12);
      fill((20.0/360.0) * 100.0, 95, 94, 100);
      text(splResults[i-1], mouseX, mouseY - 5.0);     
    }
  }
}

// Screen coordinates to geographical coordinates. 
public PVector pixelToGeo(PVector screenLocation){
  return new PVector(mapGeoLeft + (mapGeoRight-mapGeoLeft)*(screenLocation.x)/mapScreenWidth, mapGeoTop - (mapGeoTop-mapGeoBottom)*(screenLocation.y)/mapScreenHeight);
}

// Geographical coordinates to screen coordinates.
public PVector geoToPixel(PVector geoLocation){
  return new PVector(mapScreenWidth*(geoLocation.x-mapGeoLeft)/(mapGeoRight-mapGeoLeft), mapScreenHeight - mapScreenHeight*(geoLocation.y-mapGeoBottom)/(mapGeoTop-mapGeoBottom));
}

